 
#ifndef __CLASS_H
#define __CLASS_H

#include <vector>
#include <string>
#include <map>
#include <iostream>

#include "Type.h"
#include "Property.h"
#include "PrimitiveType.h"

    class Class : public Type
    {
    public:
        Class(std::string ClassName, Class* BaseClass = NULL);
        virtual ~Class();
        void Read(std::istream& in);
        
        Class* BaseClass;
        std::vector<Class*> SubClasses;
        std::vector<Property*> Members;
        
        virtual void WriteTypeDefinition(std::ostream& os);
        virtual void WriteConstructorDefinition(Property* property, std::ostream& os);

        // XML
        virtual void WriteXmlLoader(std::ostream& os);
        virtual void WriteXmlLoadCall(std::string xmlName, Property* property, std::ostream& os);
        virtual void WriteXmlSaver(std::ostream& os);
        virtual void WriteXmlSaveCall(std::string xmlName, Property* property, std::ostream& os);

        // HTTP / HTML
        virtual void WriteHtmlShow(std::ostream& os);
        virtual void WriteHtmlShowCall(Property* property, std::ostream& os);
        virtual void WriteHtmlForm(std::ostream& os);
        virtual void WriteHtmlFormCall(Property* property, std::ostream& os);
        virtual void WriteHttpPostLoader(std::ostream& os);
        virtual void WriteHttpPostLoadCall(Property* property, std::ostream& os);
    };


#endif