 
#ifndef __PROPERTY_H
#define __PROPERTY_H

#include <string>
#include <iostream>
#include "Type.h"

    class Property
    {
    public:
        Type* type;
        std::string Name;
        std::string Caption;
        bool Embedded; // Only for classes. Primitive types are always embedded
        bool Mandatory;
        bool Array;
        
        Property(Type* type, std::string Name);
        virtual ~Property();
        void Read(std::istream& in);

        virtual void WriteDeclaration(std::ostream& os);
        virtual void WriteConstructorDefinition(std::ostream& os);
        
        // XML
        virtual void WriteXmlSaveCall(std::string xmlName, std::ostream& os);
        virtual void WriteXmlLoadCall(std::string xmlName, std::ostream& os);

        // HTTP / HTML
        virtual void WriteHtmlShowCall(std::ostream& os);
        virtual void WriteHtmlFormCall(std::ostream& os);
        virtual void WriteHttpPostLoadCall(std::ostream& os);
    };

#endif
