
#include "Property.h"
using namespace std;

Property::Property(Type* type, std::string Name)
{
    this->Name = Name;
    this->type = type;
    this->Mandatory = false;
    this->Embedded = false;
    this->Array = false;
}

Property::~Property()
{
}

void Property::WriteDeclaration(ostream& os)
{
    os << "    public /*" << this->type->TypeName << "*/ $" << this->Name << ";" << endl;
}

void Property::WriteConstructorDefinition(ostream& os)
{
    this->type->WriteConstructorDefinition(this, os);
}

void Property::WriteXmlSaveCall(string xmlName, ostream& os)
{
    this->type->WriteXmlSaveCall(xmlName, this, os);
}

void Property::WriteXmlLoadCall(string xmlName, ostream& os)
{
    this->type->WriteXmlLoadCall(xmlName, this, os);
}

void Property::WriteHtmlShowCall(ostream& os)
{
    this->type->WriteHtmlShowCall(this, os);
}

void Property::WriteHtmlFormCall(ostream& os)
{
    this->type->WriteHtmlFormCall(this, os);
}

void Property::WriteHttpPostLoadCall(ostream& os)
{
    this->type->WriteHttpPostLoadCall(this, os);
}



void Property::Read(istream& in)
{
    string token;
    in >> this->Name;
    this->Caption = this->Name;
    
    for(in.peek(); !in.eof(); in.peek())
    {
        in >> token;
        if(token == ";")
            return;
    
        if(token == "@embedded")
            this->Embedded = true;
        else if(token == "@caption")
            in >> this->Caption;
        else if(token == "@mandatory")
            this->Mandatory = true;
        else if(token == "@array" || token == "@list")
            this->Array = true;
        else
            cerr << "Token \"" << token << "\" ignored." << endl;
    }
}