#include "Type.h"
#include "PrimitiveType.h"
#include "Property.h"
#include "Class.h"
#include <fstream>
using namespace std;




int main(int argc, char** argv)
{
    Class ObjectClass("Object");
    Class UserClass("User");
    
    
    string token = "";
    for(int i = 1; i < argc; i++)
    {
        ifstream classesin(argv[i]);
        
        for(classesin.peek(); !classesin.eof(); classesin.peek())
        {
            classesin >> token;
            if(token == "class")
            {
                classesin >> token; // classname
                Class* newClass = new Class(token);
                newClass->Read(classesin);
            }
            else
                cerr << "Expected \"class\", found \"" << token << "\"." << endl;
        }
        
        classesin.close();
    }
    
    
    
    // ======================================================== GENERATE OBJECT.PHP
    ofstream objout("webroot/classes/Object.php");
    objout << "<?php" << endl;

    objout << "class Object" << endl;
    objout << "{" << endl;
    objout << "    public $id = -1;" << endl << endl;

    objout << "    public function __construct()" << endl;
    objout << "    {" << endl;
    objout << "    }" << endl << endl;
    
    objout << "    public static function load($root, $id)" << endl;
    objout << "    {" << endl;
    objout << "        $filename = $root . 'objects/' . $id . '.xml';" << endl;
    objout << "        $xml = simplexml_load_file($filename);" << endl;
    objout << "        $typename = (string)$xml['type'];" << endl;
    objout << "        $result = new $typename;" << endl;
    objout << "        $result->fromXml($xml);" << endl;
    objout << "        return $result;" << endl;
    objout << "    }" << endl << endl;
    
    objout << "    public function save($root)" << endl;
    objout << "    {" << endl;
    objout << "        if($this->id <= 0)" << endl;
    objout << "        {" << endl;
    objout << "            if(!file_exists($root.'objects/nextid.ini'))" << endl;
    objout << "                file_put_contents($root.'objects/nextid.ini', 1);" << endl;
    objout << "            $handle = FALSE;" << endl;
    objout << "            while($handle === FALSE)" << endl;
    objout << "                $handle = fopen($root.'objects/nextid.ini', 'r+');" << endl;
    objout << "            $this->id = intval(fread($handle, 10));" << endl;
    objout << "            fseek($handle, 0);" << endl;
    objout << "            fwrite($handle, '' . ($this->id+1));" << endl;
    objout << "            fclose($handle);" << endl;
    objout << "        }" << endl << endl;
    
    objout << "        $filename = $root . 'objects/' . $this->id . '.xml';" << endl;
    objout << "        $xml = new SimpleXMLElement(\"<object></object>\");" << endl;
    objout << "        $this->toXml($xml);" << endl;

    objout << "        $domxml = new DOMDocument('1.0');" << endl;
    objout << "        $domxml->preserveWhiteSpace = false;" << endl;
    objout << "        $domxml->formatOutput = true;" << endl;
    objout << "        $domxml->loadXML($xml->asXML());" << endl;
    
    objout << "        if(file_exists($filename))" << endl;
    objout << "            unlink($filename);" << endl;
    objout << "        $domxml->save($filename);" << endl;

    objout << "    }" << endl << endl;

    objout << "    public function RemoteProcedureCall($prefix, $str)" << endl;
    objout << "    {" << endl;
    objout << "        return false;" << endl;
    objout << "    }" << endl << endl;
    
    objout << "    public function toXml(&$xml)" << endl;
    objout << "    {" << endl;
    objout << "        $xml->addAttribute('type', get_class($this));" << endl;
    objout << "        if($this->id > 0)" << endl;
    objout << "            $xml->addAttribute('id', $this->id);" << endl;
    objout << "    }" << endl << endl;
    
    objout << "    public function fromXml(&$xml)" << endl;
    objout << "    {" << endl;
    objout << "        if(isset($xml['id']))" << endl;
    objout << "            $this->id = intval($xml['id']);" << endl;
    objout << "    }" << endl << endl;
    
    objout << "    public function htmlView($indent, $divid)" << endl;
    objout << "    {" << endl;
    objout << "    }" << endl << endl;

    objout << "    public function htmlForm($prefix, $indent, $divid)" << endl;
    objout << "    {" << endl;
    objout << "    }" << endl << endl;

    objout << "    public function fromHttpPost(&$post)" << endl;
    objout << "    {" << endl;
    objout << "    }" << endl;
    
    objout << "}" << endl;
    objout << "?>";
    objout.close();

    // ======================================================== GENERATE USER.PHP


    ofstream userout("webroot/classes/User.php");
    userout << "<?php" << endl;

    userout << "class User extends Object" << endl;
    userout << "{" << endl;
    userout << "    public $username;" << endl;
    userout << "    public $displayname;" << endl;
    userout << "    public $email;" << endl << endl;
    userout << "    public $passwordHash;" << endl << endl;
    
    userout << "    public function __construct()" << endl;
    userout << "    {" << endl;
    userout << "        parent::__construct();" << endl;
    userout << "    }" << endl << endl;

    userout << "    public static function load($root, $username)" << endl;
    userout << "    {" << endl;
    userout << "        $filename = $root . 'accounts/' . $username . '.xml';" << endl;
    userout << "        $xml = simplexml_load_file($filename);" << endl;
    userout << "        $objectid = intval($xml['id']);" << endl;
    userout << "        $result = Object::load($root, $objectid);" << endl;
    userout << "    }" << endl << endl;

    userout << "    public function toXml(&$xml)" << endl;
    userout << "    {" << endl;
    userout << "        parent::toXml($xml);" << endl;
    userout << "        $xml->addAttribute('username', $this->username);" << endl;
    userout << "        $xml->addAttribute('displayname', $this->displayname);" << endl;
    userout << "        $xml->addAttribute('email', $this->email);" << endl;
    userout << "        $xml->addAttribute('passwordHash', $this->passwordHash);" << endl;
    userout << "    }" << endl << endl;
    
    userout << "    public function fromXml(&$xml)" << endl;
    userout << "    {" << endl;
    userout << "        parent::fromXml($xml);" << endl;
    userout << "        $this->username = (string)($xml['username']);" << endl;
    userout << "        $this->displayname = (string)($xml['displayname']);" << endl;
    userout << "        $this->email = (string)($xml['email']);" << endl;
    userout << "        $this->passwordHash = (string)($xml['passwordHash']);" << endl;
    userout << "    }" << endl;    
    userout << "}" << endl;
    userout << "?>";
    userout.close();



    // ======================================================== GENERATE OTHER CLASSES
    ofstream classesout("webroot/classes.php");
    classesout << "<?php" << endl;
    classesout << "    include 'classes/Object.php';" << endl;
    classesout << "    include 'classes/User.php';" << endl;
    for(vector<Type*>::iterator i = Type::AllTypesOrdered.begin(); i != Type::AllTypesOrdered.end(); i++)
    {
        Class* TheClass = dynamic_cast<Class*>(*i);
        if(TheClass != NULL
            && TheClass != &ObjectClass
            && TheClass != &UserClass)
        {
            classesout << "    include 'classes/" << TheClass->TypeName << ".php';" << endl;

            ofstream classout(("webroot/classes/" + TheClass->TypeName + ".php").c_str());
            classout << "<?php" << endl;
            TheClass->WriteTypeDefinition(classout);
            classout << "?>";
            classout.close();
        }
    }
    classesout << "?>";

    
    
    return 0;
}
