<?php
class Anbieter extends User
{
    public /*Person*/ $kontaktperson;
    public /*string*/ $telefonnummer;
    public /*string*/ $webseite;
    public /*Angebot*/ $angebote;

    public function __construct()
    {
        parent::__construct();
        $this->kontaktperson = new Person();
        $this->angebote = array();
    }

    public function RemoteProcedureCall($prefix, $str)
    {
        if(parent::RemoteProcedureCall($prefix, $str))
            return true;
        if(substr($str, strlen($prefix)+15) == $prefix . '[kontaktperson]')
            return $this->kontaktperson->RemoteProcedureCall($prefix . '[kontaktperson]', $str);
        if($str == $prefix . '[angebote].Add()')
            {array_push($this->angebote, new Angebot()); return true;}
        $angeboteCounter = 0;
        foreach($this->angebote as &$angeboteIterator)
        {
            $angeboteSelector = $prefix . '[angebote][' . $angeboteCounter . ']';
            if(substr($str, strlen($angeboteSelector)) == $angeboteSelector)
                return $angeboteIterator->RemoteProcedureCall($angeboteSelector, $str);
            $angeboteCounter++;
        }
        return false;
    }

    public function fromXml(&$xml)
    {
        parent::fromXml($xml);
        $kontaktpersonXmlNode = $xml->kontaktperson;
        $kontaktpersonTypeName = (string)$kontaktpersonXmlNode['type'];
        $this->kontaktperson = new $kontaktpersonTypeName;
        $this->kontaktperson->fromXml($kontaktpersonXmlNode);
        $this->telefonnummer = (string)($xml['telefonnummer']);
        $this->webseite = (string)($xml['webseite']);
        foreach($xml->angebote as $angeboteXmlNode)
        {
            $angeboteTypeName = (string)$angeboteXmlNode['type'];
            $angeboteTemp = new $angeboteTypeName;
            $angeboteTemp->fromXml($angeboteXmlNode);
            array_push($this->angebote, $angeboteTemp);
        }
    }

    public function toXml(&$xml)
    {
        parent::toXml($xml);
        $kontaktpersonXmlNode = $xml->addChild('kontaktperson');
        $this->kontaktperson->toXml($kontaktpersonXmlNode);
        $xml->addAttribute("telefonnummer", $this->telefonnummer);
        $xml->addAttribute("webseite", $this->webseite);
        foreach($this->angebote as $angeboteIterator)
        {
            $angeboteXmlNode = $xml->addChild('angebote');
            $angeboteIterator->toXml($angeboteXmlNode);
        }
    }

    public function htmlView($indent, $divid)
    {
        if($divid != null)
        {
            echo str_repeat('  ', $indent) . "<div class='composed'><div class='Anbieter' id='$divid'>";
            echo "<div class='caption'>$divid</div>\n";
        }
        parent::htmlView($indent, null);
        $this->kontaktperson->htmlView($indent+1, 'kontaktperson');
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='telefonnummer'><div class='caption'>telefonnummer</div>" . htmlspecialchars($this->telefonnummer) . "</div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='webseite'><div class='caption'>webseite</div>" . htmlspecialchars($this->webseite) . "</div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='array' id='angebote'><div class='caption'>angebote</div>\n";
        $angeboteCounter = 0;
        foreach($this->angebote as $angeboteIterator)
            $angeboteIterator->htmlView($indent+2, 'angebote');
        echo str_repeat('  ', $indent+1) . "</div>\n";
        if($divid != null)
            echo str_repeat('  ', $indent) . "</div></div>\n";
    }

    public function htmlForm($prefix, $indent, $divid)
    {
        if($divid != null)
        {
            echo str_repeat('  ', $indent) . "<div class='composed'><div class='Anbieter' id='$divid'>\n";
            echo str_repeat('  ', $indent+1) . "<div class='caption'>$divid</div>\n";
        }
        parent::htmlForm($prefix, $indent, null);
        $this->kontaktperson->htmlForm($prefix . '[kontaktperson]' , $indent+1, 'kontaktperson');
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='telefonnummer'><div class='caption'>telefonnummer</div><input type=\"text\" name=\"" . $prefix . "[telefonnummer]\" value=\"" . htmlspecialchars($this->telefonnummer) . "\"/></div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='string' id='webseite'><div class='caption'>webseite</div><input type=\"text\" name=\"" . $prefix . "[webseite]\" value=\"" . htmlspecialchars($this->webseite) . "\"/></div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='array' id='angebote'><div class='caption'>angebote</div>\n";
        $angeboteCounter = 0;
        foreach($this->angebote as $angeboteIterator)
            $angeboteIterator->htmlForm($prefix . '[angebote][' . $angeboteCounter++ . ']' , $indent+2, 'angebote');
        echo str_repeat('  ', $indent+2) . "<button type='submit' name='rpc' value='" . $prefix . "[angebote].Add()'>Add</button>\n";
        echo str_repeat('  ', $indent+1) . "</div>\n";
        if($divid != null)
            echo str_repeat('  ', $indent) . "</div></div>\n";
    }

    public function fromHttpPost(&$post)
    {
        parent::fromHttpPost($post);
        $this->kontaktperson->fromHttpPost($post['kontaktperson']);
        $this->telefonnummer = $post['telefonnummer'];
        $this->webseite = $post['webseite'];
        $angeboteCounter = 0;
        foreach($this->angebote as $angeboteIterator)
            $angeboteIterator->fromHttpPost($post['angebote'][$angeboteCounter++]);
    }
}
?>