<?php
class Brautpaar extends User
{
    public /*Person*/ $braut;
    public /*Person*/ $braeutigam;
    public /*date*/ $hochzeitsdatum;
    public /*int*/ $gaesteanzahl;
    public /*int*/ $budget;
    public /*float*/ $partystunden;
    public /*Person*/ $gaeste;
    public /*Auswahl*/ $auswahlen;

    public function __construct()
    {
        parent::__construct();
        $this->braut = new Person();
        $this->braeutigam = new Person();
        $this->gaeste = array();
        $this->auswahlen = array();
    }

    public function RemoteProcedureCall($prefix, $str)
    {
        if(parent::RemoteProcedureCall($prefix, $str))
            return true;
        if(substr($str, strlen($prefix)+7) == $prefix . '[braut]')
            return $this->braut->RemoteProcedureCall($prefix . '[braut]', $str);
        if(substr($str, strlen($prefix)+12) == $prefix . '[braeutigam]')
            return $this->braeutigam->RemoteProcedureCall($prefix . '[braeutigam]', $str);
        if($str == $prefix . '[gaeste].Add()')
            {array_push($this->gaeste, new Person()); return true;}
        $gaesteCounter = 0;
        foreach($this->gaeste as &$gaesteIterator)
        {
            $gaesteSelector = $prefix . '[gaeste][' . $gaesteCounter . ']';
            if(substr($str, strlen($gaesteSelector)) == $gaesteSelector)
                return $gaesteIterator->RemoteProcedureCall($gaesteSelector, $str);
            $gaesteCounter++;
        }
        if($str == $prefix . '[auswahlen].Add()')
            {array_push($this->auswahlen, new Auswahl()); return true;}
        $auswahlenCounter = 0;
        foreach($this->auswahlen as &$auswahlenIterator)
        {
            $auswahlenSelector = $prefix . '[auswahlen][' . $auswahlenCounter . ']';
            if(substr($str, strlen($auswahlenSelector)) == $auswahlenSelector)
                return $auswahlenIterator->RemoteProcedureCall($auswahlenSelector, $str);
            $auswahlenCounter++;
        }
        return false;
    }

    public function fromXml(&$xml)
    {
        parent::fromXml($xml);
        $brautXmlNode = $xml->braut;
        $brautTypeName = (string)$brautXmlNode['type'];
        $this->braut = new $brautTypeName;
        $this->braut->fromXml($brautXmlNode);
        $braeutigamXmlNode = $xml->braeutigam;
        $braeutigamTypeName = (string)$braeutigamXmlNode['type'];
        $this->braeutigam = new $braeutigamTypeName;
        $this->braeutigam->fromXml($braeutigamXmlNode);
        $this->hochzeitsdatum = strtotime((string)($xml['hochzeitsdatum']));
        $this->gaesteanzahl = intval((string)($xml['gaesteanzahl']));
        $this->budget = intval((string)($xml['budget']));
        $this->partystunden = floatval((string)($xml['partystunden']));
        foreach($xml->gaeste as $gaesteXmlNode)
        {
            $gaesteTypeName = (string)$gaesteXmlNode['type'];
            $gaesteTemp = new $gaesteTypeName;
            $gaesteTemp->fromXml($gaesteXmlNode);
            array_push($this->gaeste, $gaesteTemp);
        }
        foreach($xml->auswahlen as $auswahlenXmlNode)
        {
            $auswahlenTypeName = (string)$auswahlenXmlNode['type'];
            $auswahlenTemp = new $auswahlenTypeName;
            $auswahlenTemp->fromXml($auswahlenXmlNode);
            array_push($this->auswahlen, $auswahlenTemp);
        }
    }

    public function toXml(&$xml)
    {
        parent::toXml($xml);
        $brautXmlNode = $xml->addChild('braut');
        $this->braut->toXml($brautXmlNode);
        $braeutigamXmlNode = $xml->addChild('braeutigam');
        $this->braeutigam->toXml($braeutigamXmlNode);
        $xml->addAttribute("hochzeitsdatum", $this->hochzeitsdatum);
        $xml->addAttribute("gaesteanzahl", $this->gaesteanzahl);
        $xml->addAttribute("budget", $this->budget);
        $xml->addAttribute("partystunden", $this->partystunden);
        foreach($this->gaeste as $gaesteIterator)
        {
            $gaesteXmlNode = $xml->addChild('gaeste');
            $gaesteIterator->toXml($gaesteXmlNode);
        }
        foreach($this->auswahlen as $auswahlenIterator)
        {
            $auswahlenXmlNode = $xml->addChild('auswahlen');
            $auswahlenIterator->toXml($auswahlenXmlNode);
        }
    }

    public function htmlView($indent, $divid)
    {
        if($divid != null)
        {
            echo str_repeat('  ', $indent) . "<div class='composed'><div class='Brautpaar' id='$divid'>";
            echo "<div class='caption'>$divid</div>\n";
        }
        parent::htmlView($indent, null);
        $this->braut->htmlView($indent+1, 'braut');
        $this->braeutigam->htmlView($indent+1, 'braeutigam');
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='date' id='hochzeitsdatum'><div class='caption'>hochzeitsdatum</div>" . date('d.m.Y', $this->hochzeitsdatum) . "</div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='int' id='gaesteanzahl'><div class='caption'>gaesteanzahl</div>" . $this->gaesteanzahl . "</div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='int' id='budget'><div class='caption'>budget</div>" . $this->budget . "</div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='float' id='partystunden'><div class='caption'>partystunden</div>" . $this->partystunden . "</div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='array' id='gaeste'><div class='caption'>gaeste</div>\n";
        $gaesteCounter = 0;
        foreach($this->gaeste as $gaesteIterator)
            $gaesteIterator->htmlView($indent+2, 'gaeste');
        echo str_repeat('  ', $indent+1) . "</div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='array' id='auswahlen'><div class='caption'>auswahlen</div>\n";
        $auswahlenCounter = 0;
        foreach($this->auswahlen as $auswahlenIterator)
            $auswahlenIterator->htmlView($indent+2, 'auswahlen');
        echo str_repeat('  ', $indent+1) . "</div>\n";
        if($divid != null)
            echo str_repeat('  ', $indent) . "</div></div>\n";
    }

    public function htmlForm($prefix, $indent, $divid)
    {
        if($divid != null)
        {
            echo str_repeat('  ', $indent) . "<div class='composed'><div class='Brautpaar' id='$divid'>\n";
            echo str_repeat('  ', $indent+1) . "<div class='caption'>$divid</div>\n";
        }
        parent::htmlForm($prefix, $indent, null);
        $this->braut->htmlForm($prefix . '[braut]' , $indent+1, 'braut');
        $this->braeutigam->htmlForm($prefix . '[braeutigam]' , $indent+1, 'braeutigam');
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='date' id='hochzeitsdatum'><div class='caption'>hochzeitsdatum</div><input type=\"text\" name=\"" . $prefix . "[hochzeitsdatum]\" value=\"" . date('d.m.Y', $this->hochzeitsdatum) . "\"/></div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='int' id='gaesteanzahl'><div class='caption'>gaesteanzahl</div><input type=\"text\" name=\"" . $prefix . "[gaesteanzahl]\" value=\"" . $this->gaesteanzahl . "\"/></div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='int' id='budget'><div class='caption'>budget</div><input type=\"text\" name=\"" . $prefix . "[budget]\" value=\"" . $this->budget . "\"/></div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='primitive'><div class='float' id='partystunden'><div class='caption'>partystunden</div><input type=\"text\" name=\"" . $prefix . "[partystunden]\" value=\"" . $this->partystunden . "\"/></div></div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='array' id='gaeste'><div class='caption'>gaeste</div>\n";
        $gaesteCounter = 0;
        foreach($this->gaeste as $gaesteIterator)
            $gaesteIterator->htmlForm($prefix . '[gaeste][' . $gaesteCounter++ . ']' , $indent+2, 'gaeste');
        echo str_repeat('  ', $indent+2) . "<button type='submit' name='rpc' value='" . $prefix . "[gaeste].Add()'>Add</button>\n";
        echo str_repeat('  ', $indent+1) . "</div>\n";
        echo str_repeat('  ', $indent+1) . "<div class='array' id='auswahlen'><div class='caption'>auswahlen</div>\n";
        $auswahlenCounter = 0;
        foreach($this->auswahlen as $auswahlenIterator)
            $auswahlenIterator->htmlForm($prefix . '[auswahlen][' . $auswahlenCounter++ . ']' , $indent+2, 'auswahlen');
        echo str_repeat('  ', $indent+2) . "<button type='submit' name='rpc' value='" . $prefix . "[auswahlen].Add()'>Add</button>\n";
        echo str_repeat('  ', $indent+1) . "</div>\n";
        if($divid != null)
            echo str_repeat('  ', $indent) . "</div></div>\n";
    }

    public function fromHttpPost(&$post)
    {
        parent::fromHttpPost($post);
        $this->braut->fromHttpPost($post['braut']);
        $this->braeutigam->fromHttpPost($post['braeutigam']);
        $this->hochzeitsdatum = strtotime($post['hochzeitsdatum']);
        $this->gaesteanzahl = intval($post['gaesteanzahl']);
        $this->budget = intval($post['budget']);
        $this->partystunden = floatval($post['partystunden']);
        $gaesteCounter = 0;
        foreach($this->gaeste as $gaesteIterator)
            $gaesteIterator->fromHttpPost($post['gaeste'][$gaesteCounter++]);
        $auswahlenCounter = 0;
        foreach($this->auswahlen as $auswahlenIterator)
            $auswahlenIterator->fromHttpPost($post['auswahlen'][$auswahlenCounter++]);
    }
}
?>