<?php
class Object
{
    public $id = -1;

    public function __construct()
    {
    }

    public static function load($root, $id)
    {
        $filename = $root . 'objects/' . $id . '.xml';
        $xml = simplexml_load_file($filename);
        $typename = (string)$xml['type'];
        $result = new $typename;
        $result->fromXml($xml);
        return $result;
    }

    public function save($root)
    {
        if($this->id <= 0)
        {
            if(!file_exists($root.'objects/nextid.ini'))
                file_put_contents($root.'objects/nextid.ini', 1);
            $handle = FALSE;
            while($handle === FALSE)
                $handle = fopen($root.'objects/nextid.ini', 'r+');
            $this->id = intval(fread($handle, 10));
            fseek($handle, 0);
            fwrite($handle, '' . ($this->id+1));
            fclose($handle);
        }

        $filename = $root . 'objects/' . $this->id . '.xml';
        $xml = new SimpleXMLElement("<object></object>");
        $this->toXml($xml);
        $domxml = new DOMDocument('1.0');
        $domxml->preserveWhiteSpace = false;
        $domxml->formatOutput = true;
        $domxml->loadXML($xml->asXML());
        if(file_exists($filename))
            unlink($filename);
        $domxml->save($filename);
    }

    public function RemoteProcedureCall($prefix, $str)
    {
        return false;
    }

    public function toXml(&$xml)
    {
        $xml->addAttribute('type', get_class($this));
        if($this->id > 0)
            $xml->addAttribute('id', $this->id);
    }

    public function fromXml(&$xml)
    {
        if(isset($xml['id']))
            $this->id = intval($xml['id']);
    }

    public function htmlView($indent, $divid)
    {
    }

    public function htmlForm($prefix, $indent, $divid)
    {
    }

    public function fromHttpPost(&$post)
    {
    }
}
?>